﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Xml.Linq;

namespace UMK
{
    public class SettingsManager<T>
        where T : class, new()
    {
        //private T settingsObject;

        private Dictionary<string, object> values = new Dictionary<string, object>();
        private string path;
        private bool useDefaultValuesInsteadOfThrowingException;
        private IFormatProvider formatProvider;

        private SettingsManager(Dictionary<string, object> values, string path, bool useDefaultValuesInsteadOfThrowingException = false, IFormatProvider formatProvider = null)
        {
            if (formatProvider == null) formatProvider = System.Globalization.CultureInfo.InvariantCulture;

            this.values = values;
            this.path = path;
            this.useDefaultValuesInsteadOfThrowingException = useDefaultValuesInsteadOfThrowingException;
            this.formatProvider = formatProvider;
        }

        public SettingsManager(T settingsObject, string path, bool useDefaultValuesInsteadOfThrowingException = false, IFormatProvider formatProvider = null)
            : this(extractValues(settingsObject), path, useDefaultValuesInsteadOfThrowingException, formatProvider)
        {
            //tu ma nic nie być
        }

        private static bool isPropert(FieldInfo field)
        {
            return true; //TODO: trzeba ustalić warunki serializacji
        }

        private static bool isPropert(PropertyInfo property)
        {
            return true; //TODO: trzeba ustalić warunki serializacji
        }

        private static Dictionary<string, object> extractValues(T settingsObject)
        {
            if (settingsObject == null) throw new SettingsException("Empty object");

            Dictionary<string, object> values = new Dictionary<string, object>();

            //FieldInfo[] fields = settingsObject.GetType().GetFields();            
            //FieldInfo[] fields = typeof(T).GetFields(BindingFlags.NonPublic | BindingFlags.Instance);
            FieldInfo[] fields = typeof(T).GetFields();
            foreach (FieldInfo field in fields)
            {
                if(isPropert(field))
                {
                    object value = field.GetValue(settingsObject);
                    values.Add(field.Name, value);
                }
            }

            PropertyInfo[] properties = typeof(T).GetProperties();
            foreach (PropertyInfo property in properties)
            {
                if (isPropert(property))
                {
                    object value = property.GetValue(settingsObject);
                    values.Add(property.Name, value);
                }
            }

            return values;
        }
    }

    public class SettingsException : Exception
    {
        public SettingsException(string message = null, Exception innerException = null)
            : base(message, innerException)
        {
        }
    }

    private bool Save()
    {
        XDocument xml = new XDocument(
        {

        }
    }
}
